/*^^!
* @^^file LPC_M5_Include.h
*
* @^^brief Costanti e tipi che vengono utilizzati dalle funzioni interne di LPC
*
* Questo file contiene valori costanti del Modulo 5
* del compito di LPC, non esposti nell'interfaccia
*
*
* @^^author Stefano Guerrini
* @^^author Andrea Sterbini
* @^^author Gianni Campanile
* @^^date	  Gennaio 2006
* @^^version 1.0
*********************************************************************/

#ifndef _LPC_M5_INCLUDE_INCLUDED_
#define _LPC_M5_INCLUDE_INCLUDED_

#include "LPC_Include.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/********** FUNZIONI DI LPC ************/
/** @^^defgroup M5Funzioni  Modulo5 - Funzioni
*
* Funzioni
* @^^{
	*/

int SearchPair(FILE *file, FIELD_VALUE_t *FieldValue, int fieldSize, int type, long knownpos, long *position) ;
FILE * openIndexFile(char * dbfname, char * fieldname, char * modo);
int scandisci_e_decrementa(FILE * indexfile, int fieldsize, long position) ;
int scandisci_e_incrementa(FILE * indexfile, char * val, int fieldsize, int type, long position) ;
int errore(char * fn, int code, char * messaggio) ;
int comparePair( void * A, long pos, void * B, int size, int type, long knownpos);
int sign(int x);
int compare_str(void *str1, void *str2, int size);
int compare_log(void *c1, void *c2, int size);
int compare_date(void *l1, void *l2, int size);
int compare_int(void *d1, void *d2, int size);
void decodeNBOValue(void *value, int type);
void encodeNBOValue(void *value, int type);
int accessIndexFile(char * dbfname, char * fieldname, int modo);
int compareValues( void * A, void * B, int size, int type);
int comparePair( void * A, long pos, void * B, int size, int type, long knownpos);

/** @^^} */	// Fine gruppo M5Funzioni

#endif // _LPC_M5_INCLUDE_INCLUDED_
